package bin;

import kernel.ps.ProcessHandle;
import kernel.ps.Process;
import kernel.peripherals.Peripherals.Peripheral;
import kernel.peripherals.Side;

using tink.CoreApi;

class Redstone implements Process {
	public function new() {}

	public function run(handle: ProcessHandle):Void {
		var subcommand = handle.args[0];

		if (subcommand == null) {
			handle.write("Usage: redstone <on|off|get> <side>");
			return handle.close(false);
		}

		var side:Null<Side> = handle.args[1];
		if (side == null) {
			handle.write("Invalid side");
			return handle.close(false);
		}

		switch (subcommand) {
			case "on":
				Peripheral.instance.getRedstone(side).setOutput(true);
			case "off":
				Peripheral.instance.getRedstone(side).setOutput(false);
			case "get":
				var value = Peripheral.instance.getRedstone(side).getAnalogInput();
				handle.write("Analog input: " + value);
			case "help":
				handle.write("Usage: redstone <on|off|get> <side>");
			default:
				handle.write("Invalid subcommand");
				return handle.close(false);
		}

		return handle.close();
	}
}
